/* This is free software.  See LICENSE for terms.
 * Copyright 2004, 2013 by Patricia Kirk.
 *
 * Originally:
 *
 * Copyright (c) 1985, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * with the normal terms and later
 * modified by various others.
 *
 */

#include "globals.h"
#include "extern.h"

/*
 * Two routines to do the necessary byte swapping for timed protocol
 * messages. Protocol is defined in /usr/include/protocols/timed.h
 */
void bytenetorder(struct tsp *ptr) {
    ptr->tsp_seq = htons((u_short) ptr->tsp_seq);
    switch (ptr->tsp_type) {

	case TSP_SETTIME:
	case TSP_ADJTIME:
	case TSP_SETDATE:
	case TSP_SETDATEREQ:
	    ptr->tsp_time.tv_sec = htonl((u_long) ptr->tsp_time.tv_sec);
	    ptr->tsp_time.tv_usec = htonl((u_long) ptr->tsp_time.tv_usec);
	    break;
	default:
	    break;		/* nothing more needed */
    }
}

void bytehostorder(struct tsp *ptr) {
    ptr->tsp_seq = ntohs((u_short) ptr->tsp_seq);
    switch (ptr->tsp_type) {

	case TSP_SETTIME:
	case TSP_ADJTIME:
	case TSP_SETDATE:
	case TSP_SETDATEREQ:
	    ptr->tsp_time.tv_sec = ntohl((u_long) ptr->tsp_time.tv_sec);
	    ptr->tsp_time.tv_usec = ntohl((u_long) ptr->tsp_time.tv_usec);
	    break;
	default:
	    break;		/* nothing more needed */
    }
}
