/* This is free software.  See LICENSE for terms.
 * Copyright 2004, 2013 by Patricia Kirk.
 *
 * Originally:
 *
 * Copyright (c) 1985, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * with the normal terms and later
 * modified by various others.
 *
 */

struct hosttbl;
struct netinfo;
struct sockaddr_in;
struct timeval;
struct tsp;

struct hosttbl *addmach(char *, struct sockaddr_in *, struct netinfo *);
struct hosttbl *findhost(char *);
struct hosttbl *remmach(struct hosttbl *);

struct tsp *readmsg(int,
	    char *, struct timeval *, struct netinfo *);
struct tsp *acksend(struct tsp *,
	    struct sockaddr_in *, char *, int, struct netinfo *, int);

void	 addnetname(char *);
void	 adj_msg_time(struct tsp *, struct timeval *);
void	 bytehostorder(struct tsp *);
void	 bytenetorder(struct tsp *);
void	 byteorder(struct tsp *);
long	 casual(long, long);
int	 cksum(u_short *, int);
void	 correct(long);
char	*date(void);
void	 doquit(struct tsp *);
int	 election(struct netinfo *);
void	 get_goodgroup(int);
int	 good_host_name(char *);
void	 ignoreack(void);
int	 in_cksum(u_short *, int);
void	 lookformaster(struct netinfo *);
void	 makeslave(struct netinfo *);
int	 master(void);
void	 masterack(void);
void	 masterup(struct netinfo *);
int	 measure(u_long, u_long, char *, struct sockaddr_in *, int);
void	 msterup(struct netinfo *);
void	 mstotvround(struct timeval *, long);
long	 networkdelta(void);
void	 newslave(struct tsp *);
void	 print(struct tsp *, struct sockaddr_in *);
void	 prthp(clock_t);
void	 rmnetmachs(struct netinfo *);
void	 setstatus(void);
int	 slave(void);
void	 slaveack(void);
void	 spreadtime(void);
void	 suppress(struct sockaddr_in *, char *, struct netinfo *);
void	 synch(long);
void	 timevaladd(struct timeval *, struct timeval *);
void	 timevalsub(struct timeval *, struct timeval *, struct timeval *);
void	 traceoff(char *);
void	 traceon(void);
void	 xmit(int, u_int, struct sockaddr_in *);

#if __STDC__
struct tsp;
#endif

void	bytehostorder(struct tsp *);
void	bytenetorder(struct tsp *);
void	clockdiff(int, char *[]);
void	help(int, char *[]);
void	intr(int);
void	makeargv(void);
void	msite(int, char *[]);
int	priv_resources(void);
void	quit(void);
void	testing(int, char *[]);
void	tracing(int, char *[]);
